% This function is used to implement iterative refinement
%
% x=iterna(a,l,u,p,f);
%
% programmer: C. Vuik, TU Delft, The Netherlands
% e-mail    : c.vuik@tudelft.nl
% date      : 02-02-2023
% course    : Computational Fluid Dynamics II
%             a PhD course from the JM Burgerscentrum
%

function x=iterna(a,l,u,p,f);
clear r y
format long e
r = f;
i = 0;
x = 0;
disp(' ')
disp(' ')
disp('     iteration                 norm of the residual')
disp('     ---------                 --------------------')
disp(' ')
disp(' ')
while norm(r) > 10^(-10) & i < 50
  i = i+1;
  y = l\p*r;
  x = x+u\y;
  r = f-a*x;
  disp([i,norm(r)])
end
  
