% This function is used to implement the CG iterative method
%
% x=idema(a,f,reps);
%
% programmer: C. Vuik, TU Delft, The Netherlands
% e-mail    : c.vuik@tudelft.nl
% date      : 02-02-2023
% course    : Computational Fluid Dynamics II
%             a PhD course from the JM Burgerscentrum
%

function x=idema(a,f,reps);
close all
clear x n1 n2 n m r
format long e
r = f;
disp(' ')
disp(' ')
disp('     iteration                 norm of the residual')
disp('     ---------                 --------------------')
disp(' ')
disp(' ')
bnorm = norm(f);
i = 0;
x = 0*f;
r = f;
s = f;
while (norm(r)/bnorm) > reps & i < 1000
  i = i+1;
  rnormold = r'*r;
  alfa = rnormold/(s'*(a*s));
  x = x+alfa*s;
  r = r-alfa*a*s;
  beta = r'*r/rnormold;
  as = a*s;
  s = r+beta*s;
  loodrecht = as'*s
  pause
  res(i) = norm(r);
  disp([i,norm(r)])
end
for j = 1 : (i-1)
   fac(j) = res(j+1)/res(j);
end
res = log10(res);
subplot(2,1,1);
plot(res);
title(' The iterations using Conjugate Gradients')
xlabel(' iterations')
ylabel(' 10log(residu)')  
subplot(2,1,2);
plot(fac)
title(' The reduction factor |r_(i+1)|/|r_i)|')
xlabel(' iterations')
ylabel(' factor')
